package com.hand.hls.web.svc;

import com.hand.hap.core.web.view.XMap;
import freemarker.template.Template;
import freemarker.template.TemplateException;
import org.springframework.web.servlet.support.RequestContextUtils;

import java.io.IOException;
import java.io.StringWriter;
import java.util.Locale;
import java.util.Map;

public abstract class ServiceTag {

    public static final String DEFAULT_NAME_SPACE = "http://www.hand-china.com/hap";
    public static final String DEFAULT_TAG_PREFIX = "h";

    public void init(XMap view, ServiceContext context) throws Exception {
    }

    public abstract String execute(XMap view, ServiceContext context) throws Exception;

    protected String build(ServiceContext context, String templateName) throws IOException, TemplateException {
        String html = "";
        try (StringWriter out = new StringWriter()) {
            Locale locale = RequestContextUtils.getLocale(context.getRequest());
            Template template = context.getConfiguration().getTemplate(templateName, locale);
            Map<String, Object> map = context.getFreeMarkerModel();
            template.process(map, out);
            out.flush();
            html = out.toString();
        }
        return html;
    }
}
