package com.hand.hls.web.svc.controllers;

import com.hand.hap.core.impl.RequestHelper;
import com.hand.hap.system.controllers.BaseController;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;

/**
 * Created with IntelliJ IDEA.
 * User: yang
 * Date: 2017-11-27
 * Time: 15:55
 */
//@RestController
public class ServiceController extends BaseController {
    @RequestMapping(value = "/{folder1}/{name}.service")
    public ModelAndView renderFolder1View(HttpServletRequest request, @PathVariable String folder1, @PathVariable String name, Model model) {
        RequestHelper.setCurrentRequest(createRequestContext(request));
        return new ModelAndView(
                new StringBuilder(getViewPath()).append("/").append(folder1).append("/").append(name).toString());
    }

    @RequestMapping(value = "/{folder1}/{folder2}/{name}.service")
    public ModelAndView renderFolder2View(HttpServletRequest request, @PathVariable String folder1, @PathVariable String folder2,
                                          @PathVariable String name, Model model) {
        RequestHelper.setCurrentRequest(createRequestContext(request));
        return new ModelAndView(new StringBuilder(getViewPath()).append("/").append(folder1).append("/").append(folder2)
                .append("/").append(name).toString());
    }


    @RequestMapping(value = "/{folder1}/{folder2}/{folder3}/{name}.service")
    public ModelAndView renderFolder3View(HttpServletRequest request, @PathVariable String folder1, @PathVariable String folder2,
                                          @PathVariable String folder3, @PathVariable String name, Model model) {
        RequestHelper.setCurrentRequest(createRequestContext(request));
        return new ModelAndView(new StringBuilder(getViewPath()).append("/").append(folder1).append("/").append(folder2)
                .append("/").append(folder3).append("/").append(name).toString());
    }

    @RequestMapping(value = "/{folder1}/{folder2}/{folder3}/{folder4}/{name}.service")
    public ModelAndView renderFolder4View(HttpServletRequest request, @PathVariable String folder1, @PathVariable String folder2,
                                          @PathVariable String folder3, @PathVariable String folder4, @PathVariable String name, Model model) {
        RequestHelper.setCurrentRequest(createRequestContext(request));
        return new ModelAndView(new StringBuilder(getViewPath()).append("/").append(folder1).append("/").append(folder2)
                .append("/").append(folder3).append("/").append(folder4).append("/").append(name).toString());
    }

    @RequestMapping(value = "/{name}.service")
    public ModelAndView renderView(HttpServletRequest request, @PathVariable String name, Model model) {
        RequestHelper.setCurrentRequest(createRequestContext(request));
        return new ModelAndView(name);
    }
}
